import json
from webapp2 import RequestHandler
from ..models.error import ErrorModel


class BaseHandler(RequestHandler):

    def getIp(self):
        return self.request.remote_addr

    def getJsonBody(self):
        try:
            return json.loads(self.request.body)
        except:
            return {}

    def getParameter(self, parameter):
        return self.request.get(parameter)

    def sendJson(self, obj, status=None):
        self.response.status = status if status else (400 if ErrorModel.isObject(obj) else 200)
        self.response.headers['Access-Control-Allow-Origin'] = '*'
        self.response.headers['Content-Type'] = 'application/json'
        self.response.out.write(json.dumps(obj))

    def options(self, *args):
        self.response.headers['Access-Control-Allow-Origin'] = '*'
        self.response.headers['Access-Control-Allow-Headers'] = 'Origin, X-Requested-With, Content-Type, Accept'
        self.response.headers['Access-Control-Allow-Methods'] = 'POST, GET, PUT, DELETE'