from google.appengine.ext import ndb


class Model(ndb.Model):

    def id(self):
        return str(self.key.id())

    def keyString(self):
        return self.key.urlsafe()

    def delete(self):
        self.key.delete()

    def parent(self):
        return self.key.parent()

    def save(self):
        return self.put()

    @classmethod
    @ndb.transactional(xg=True)
    def saveAll(cls, array):
        ndb.put_multi(array)

    @classmethod
    @ndb.transactional(xg=True)
    def deleteAll(cls, array):
        if array.count() == 0: return
        ndb.delete_multi([key for key in array.iter(keys_only=True)])

    @classmethod
    def getById(cls, id, parentKey=None):
        try:
            return cls.get_by_id(long(id), parent=parentKey) if id.isdigit() else None
        except:
            return None

    @classmethod
    def getByKey(cls, keyString):
        try:
            key = ndb.Key(urlsafe=keyString)
            obj = key.get()
        except:
            return None

        return obj if key and key.kind() == cls.__name__ else None